#<profile4xi profile = "10" />  
# -------------------------------------------------------------------------------------------------
#<program4xi program = "log_to_stderr4xi.py">
#<abstract4xi abstract = "providing function log_to_stderr4xi"/>
#<refer4xi reference = "util.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'log_to_stderr4xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import itertools
    import weakref
    import atexit         
except:
    pass
try:                 # rare ones
    import logging          
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    pass
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from get_logger4xi import get_logger4xi
import constant_logger4xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global _log_to_stderr4xi
#"
#/>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "log-to-stderr4xi" usage = "
#   turns on logging and adds a handler which prints to stderr
#
#   forking.py
#       from .util import _logger, _log_to_stderr
#       log_to_stderr=_log_to_stderr 
#       if 'log_to_stderr' in data and data['log_to_stderr']:
#           util.log_to_stderr()
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def log_to_stderr4xi(level=None):
    '''
    log_to_stderr4xi function turns on logging and adds a handler which prints to stderr
    '''
    global _log_to_stderr4xi
    
    class2print = "log_to_stderr4xi"
    method2print = "log_to_stderr4xi"
    
    # --------------------------------------------------------------------------------------------- 
    #
    # --------------------------------------------------------------------------------------------- 
           
    message2print = "{started" + "; log-to-stderr4xi-started: " + str(log_to_stderr4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    
    message2print = "{passed" + "; level-passed-to-log-to-stderr4xi: " + str(level) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
            
    # --------------------------------------------------------------------------------------------- 
    #
    # --------------------------------------------------------------------------------------------- 
   
    logger2xi = get_logger4xi()
    
    message2print = "{set" + "; logger2xi-set-by-log-to-stderr4xi to: " + str(logger2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
            
    # --------------------------------------------------------------------------------------------- 
    #
    # --------------------------------------------------------------------------------------------- 
       
    formatter2xi = logging.Formatter(DEFAULT_LOGGING_FORMAT_LOGGER4XI)
    
    message2print = "{set" + "; formatter2xi-set-by-log-to-stderr4xi to: " + str(formatter2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
     
    # --------------------------------------------------------------------------------------------- 
    #
    # --------------------------------------------------------------------------------------------- 
       
    handler2xi = logging.StreamHandler()
    
    message2print = "{set" + "; handler2xi-set-by-log-to-stderr4xi to: " + str(handler2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
       
    handler2xi.setFormatter(formatter2xi)
    
    # --------------------------------------------------------------------------------------------- 
    #
    # --------------------------------------------------------------------------------------------- 
    message2print = "{passing" + "; handler2xi-passing-to-logger2xi-addHandler-by-log-to-stderr4xi: " + str(handler2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
        
               
    logger2xi.addHandler(handler2xi)
    
    message2print = "{performed" + "; logger2xi-addHandler-performed-by-log-to-stderr4x: " + str(logger2xi.addHandler) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
            
    
    # --------------------------------------------------------------------------------------------- 
    #
    # --------------------------------------------------------------------------------------------- 
       
    if level is not None:
    
        message2print = "{passing" + "; level-passing-to-logger2xi-setLevel-by-log-to-stderr4xi: " + str(level) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
  
        logger2xi.setLevel(level)
        
    _log_to_stderr4xi = True
    
    
    message2print = "{set" + "; log_to_stderr4xi-set-by-log-to-stderr4xi to: " + str(_log_to_stderr4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
       
    
    # --------------------------------------------------------------------------------------------- 
    #
    # --------------------------------------------------------------------------------------------- 
       
    message2print = "{returning" + "; log-to-stderr4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                
 
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of log_to_stderr4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

